#include <Adafruit_NeoPixel.h>//Incluimos la librería en el código
#include "DHT.h"

#define PIN        6
#define NUMPIXELS 10 
#define DHTPIN     8
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
#define DELAYVAL   0

//Definir variables a utilizar 
//Para potenciometros
const int pot1 = 0;
const int pot2 = 1;
const int pot3 = 2;
//Intensidad de luz
int brillo1;
int brillo2;
int brillo3;
//Variable de botón
int buttonState;
//Cambio de manualidad en el botón
int modo = 1;
int lastButtonState = LOW;
//Varibles de Sensor DHT11
float h;
float t;
const int buttonPin = 7;
unsigned long lastDebounceTime = 0;
unsigned long debounceDelay = 25;

void setup() {
  pinMode (buttonPin,INPUT);
  pixels.begin(); 
  dht.begin();
}

void loop() {
  pixels.clear(); // Apagar los LEDs
  int  reading = digitalRead(buttonPin);
  
  if (reading != lastButtonState) {
    lastDebounceTime = millis();
  }
  
  
  if ((millis() - lastDebounceTime) > debounceDelay) {
    if (reading != buttonState) {
      buttonState = reading;

      //Definir el estado del botón
      if (buttonState == HIGH) {
        if (modo == 1) {
          modo = 0; //DEfinir modo manual
        } else {
          modo = 1; //Definir modo automático
        }
      }
    }
  }
  //Estaodo de botón
  lastButtonState = reading;

  //Modo Manual
  if (modo == 0) {
      brillo1 = analogRead (pot1) / 4; 
      brillo2 = analogRead (pot2) / 4;
      brillo3 = analogRead (pot3) / 4;
      pixels.setPixelColor(0, pixels.Color(brillo1, brillo2, brillo3));
      pixels.show();   
      delay(DELAYVAL); 
  } else { //mModo automático
       h = (dht.readHumidity());
       t = (dht.readTemperature());
       //Cambios de color partiendo de la temperatura
       if (t>35){ 
         pixels.setPixelColor(0, pixels.Color(250,0,h));
         pixels.show();//Mostramos el color
         delay(DELAYVAL);
       }
       if (t<35 && t>30) {
          pixels.setPixelColor(0, pixels.Color(100,40,h));
          pixels.show();//Mostramos el color
          delay(DELAYVAL);
       }
       if (t<30 && t>25) {
          pixels.setPixelColor(0, pixels.Color(h,100,100));
          pixels.show();//Mostramos el color
          delay(DELAYVAL);
       }
       if (t<25 && t>20) {
          pixels.setPixelColor(0, pixels.Color(0,100,h));
          pixels.show();//Mostramos el color
          delay(DELAYVAL);
       }
         if (t<20 && t>15){
           pixels.setPixelColor(0, pixels.Color(20,h,250));
           pixels.show();//Mostramos el color
           delay(DELAYVAL);
       }
         if (t<15){
           pixels.setPixelColor(0, pixels.Color(h,40,250));
           pixels.show();//Mostramos el color
           delay(DELAYVAL);
    }
    lastButtonState = reading;
  }
}
